import { createVuexDecorator } from './utils';
function createGetterFunction(value, options) {
    var getter = function (state) {
        var referenceResult = value.call(state);
        if (options.mode === 'reference' && typeof referenceResult !== 'object') {
            throw Error('The property is not an object so it cannot be passed as a reference.');
        }
        else if (options.mode === 'value' && typeof referenceResult === 'object') {
            var valueResult = Object.assign({}, referenceResult);
            return valueResult;
        }
        return referenceResult;
    };
    return getter;
}
export function Getter(options) {
    if (options === void 0) { options = {}; }
    return createVuexDecorator(function (componentOptions, k, description) {
        if (typeof componentOptions.getters !== 'object') {
            componentOptions.getters = Object.create(null);
        }
        componentOptions.getters[k] = createGetterFunction(description.value, options);
    });
}
